// Auto-generated. Do not edit!

// (in-package hector_worldmodel_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ObjectInfo = require('./ObjectInfo.js');
let ObjectState = require('./ObjectState.js');
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Object {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.pose = null;
      this.info = null;
      this.state = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseWithCovariance();
      }
      if (initObj.hasOwnProperty('info')) {
        this.info = initObj.info
      }
      else {
        this.info = new ObjectInfo();
      }
      if (initObj.hasOwnProperty('state')) {
        this.state = initObj.state
      }
      else {
        this.state = new ObjectState();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Object
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseWithCovariance.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [info]
    bufferOffset = ObjectInfo.serialize(obj.info, buffer, bufferOffset);
    // Serialize message field [state]
    bufferOffset = ObjectState.serialize(obj.state, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Object
    let len;
    let data = new Object(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseWithCovariance.deserialize(buffer, bufferOffset);
    // Deserialize message field [info]
    data.info = ObjectInfo.deserialize(buffer, bufferOffset);
    // Deserialize message field [state]
    data.state = ObjectState.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += ObjectInfo.getMessageSize(object.info);
    return length + 345;
  }

  static datatype() {
    // Returns string type for a message object
    return 'hector_worldmodel_msgs/Object';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '02dea96e80640703553490052f13918d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # hector_worldmodel_msgs/Object
    # This message represents an estimate of an object's pose and identity.
    
    # The header.
    #   stamp: Timestamp of last update.
    #   frame_id: Coordinate frame, in which the pose is given
    Header header
    
    # The pose
    geometry_msgs/PoseWithCovariance pose
    
    # Further information about the object
    ObjectInfo info
    
    # The tracked state of the object
    ObjectState state
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/PoseWithCovariance
    # This represents a pose in free space with uncertainty.
    
    Pose pose
    
    # Row-major representation of the 6x6 covariance matrix
    # The orientation parameters use a fixed-axis representation.
    # In order, the parameters are:
    # (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
    float64[36] covariance
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectInfo
    # hector_worldmodel_msgs/ObjectInfo
    # This message contains information about the estimated class affiliation, object id and corresponding support
    
    # A string identifying the object's class (all objects of a class look the same)
    string class_id
    
    # A string identifying the specific object
    string object_id
    
    # A string that contains the name or a description of the specific object
    string name
    
    # The support (degree of belief) of the object's presence given as log odd ratio
    float32 support
    
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectState
    # The state of an object estimate used to track
    # states smaller than 0 disable all updates
    
    # Predefined states. Use states smaller than 0 or bigger than 63 for user defined states.
    int8 UNKNOWN = 0
    int8 PENDING = 1
    int8 ACTIVE  = 2
    int8 INACTIVE = 3
    int8 CONFIRMED = -1
    int8 DISCARDED = -2
    int8 APPROACHING = -3
    
    int8 state
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Object(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseWithCovariance.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseWithCovariance()
    }

    if (msg.info !== undefined) {
      resolved.info = ObjectInfo.Resolve(msg.info)
    }
    else {
      resolved.info = new ObjectInfo()
    }

    if (msg.state !== undefined) {
      resolved.state = ObjectState.Resolve(msg.state)
    }
    else {
      resolved.state = new ObjectState()
    }

    return resolved;
    }
};

module.exports = Object;
