// Auto-generated. Do not edit!

// (in-package hector_worldmodel_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Object = require('../msg/Object.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class AddObjectRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.object = null;
      this.map_to_next_obstacle = null;
    }
    else {
      if (initObj.hasOwnProperty('object')) {
        this.object = initObj.object
      }
      else {
        this.object = new Object();
      }
      if (initObj.hasOwnProperty('map_to_next_obstacle')) {
        this.map_to_next_obstacle = initObj.map_to_next_obstacle
      }
      else {
        this.map_to_next_obstacle = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AddObjectRequest
    // Serialize message field [object]
    bufferOffset = Object.serialize(obj.object, buffer, bufferOffset);
    // Serialize message field [map_to_next_obstacle]
    bufferOffset = _serializer.bool(obj.map_to_next_obstacle, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AddObjectRequest
    let len;
    let data = new AddObjectRequest(null);
    // Deserialize message field [object]
    data.object = Object.deserialize(buffer, bufferOffset);
    // Deserialize message field [map_to_next_obstacle]
    data.map_to_next_obstacle = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Object.getMessageSize(object.object);
    return length + 1;
  }

  static datatype() {
    // Returns string type for a service object
    return 'hector_worldmodel_msgs/AddObjectRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e8c82f515de9d91badcd349a0de2b742';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    Object object
    
    
    bool map_to_next_obstacle
    
    ================================================================================
    MSG: hector_worldmodel_msgs/Object
    # hector_worldmodel_msgs/Object
    # This message represents an estimate of an object's pose and identity.
    
    # The header.
    #   stamp: Timestamp of last update.
    #   frame_id: Coordinate frame, in which the pose is given
    Header header
    
    # The pose
    geometry_msgs/PoseWithCovariance pose
    
    # Further information about the object
    ObjectInfo info
    
    # The tracked state of the object
    ObjectState state
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/PoseWithCovariance
    # This represents a pose in free space with uncertainty.
    
    Pose pose
    
    # Row-major representation of the 6x6 covariance matrix
    # The orientation parameters use a fixed-axis representation.
    # In order, the parameters are:
    # (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
    float64[36] covariance
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectInfo
    # hector_worldmodel_msgs/ObjectInfo
    # This message contains information about the estimated class affiliation, object id and corresponding support
    
    # A string identifying the object's class (all objects of a class look the same)
    string class_id
    
    # A string identifying the specific object
    string object_id
    
    # A string that contains the name or a description of the specific object
    string name
    
    # The support (degree of belief) of the object's presence given as log odd ratio
    float32 support
    
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectState
    # The state of an object estimate used to track
    # states smaller than 0 disable all updates
    
    # Predefined states. Use states smaller than 0 or bigger than 63 for user defined states.
    int8 UNKNOWN = 0
    int8 PENDING = 1
    int8 ACTIVE  = 2
    int8 INACTIVE = 3
    int8 CONFIRMED = -1
    int8 DISCARDED = -2
    int8 APPROACHING = -3
    
    int8 state
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AddObjectRequest(null);
    if (msg.object !== undefined) {
      resolved.object = Object.Resolve(msg.object)
    }
    else {
      resolved.object = new Object()
    }

    if (msg.map_to_next_obstacle !== undefined) {
      resolved.map_to_next_obstacle = msg.map_to_next_obstacle;
    }
    else {
      resolved.map_to_next_obstacle = false
    }

    return resolved;
    }
};

class AddObjectResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.object = null;
    }
    else {
      if (initObj.hasOwnProperty('object')) {
        this.object = initObj.object
      }
      else {
        this.object = new Object();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AddObjectResponse
    // Serialize message field [object]
    bufferOffset = Object.serialize(obj.object, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AddObjectResponse
    let len;
    let data = new AddObjectResponse(null);
    // Deserialize message field [object]
    data.object = Object.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Object.getMessageSize(object.object);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'hector_worldmodel_msgs/AddObjectResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '45a6d744054ce4dbd66f71ccfdc20273';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    Object object
    
    
    ================================================================================
    MSG: hector_worldmodel_msgs/Object
    # hector_worldmodel_msgs/Object
    # This message represents an estimate of an object's pose and identity.
    
    # The header.
    #   stamp: Timestamp of last update.
    #   frame_id: Coordinate frame, in which the pose is given
    Header header
    
    # The pose
    geometry_msgs/PoseWithCovariance pose
    
    # Further information about the object
    ObjectInfo info
    
    # The tracked state of the object
    ObjectState state
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/PoseWithCovariance
    # This represents a pose in free space with uncertainty.
    
    Pose pose
    
    # Row-major representation of the 6x6 covariance matrix
    # The orientation parameters use a fixed-axis representation.
    # In order, the parameters are:
    # (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
    float64[36] covariance
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectInfo
    # hector_worldmodel_msgs/ObjectInfo
    # This message contains information about the estimated class affiliation, object id and corresponding support
    
    # A string identifying the object's class (all objects of a class look the same)
    string class_id
    
    # A string identifying the specific object
    string object_id
    
    # A string that contains the name or a description of the specific object
    string name
    
    # The support (degree of belief) of the object's presence given as log odd ratio
    float32 support
    
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectState
    # The state of an object estimate used to track
    # states smaller than 0 disable all updates
    
    # Predefined states. Use states smaller than 0 or bigger than 63 for user defined states.
    int8 UNKNOWN = 0
    int8 PENDING = 1
    int8 ACTIVE  = 2
    int8 INACTIVE = 3
    int8 CONFIRMED = -1
    int8 DISCARDED = -2
    int8 APPROACHING = -3
    
    int8 state
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AddObjectResponse(null);
    if (msg.object !== undefined) {
      resolved.object = Object.Resolve(msg.object)
    }
    else {
      resolved.object = new Object()
    }

    return resolved;
    }
};

module.exports = {
  Request: AddObjectRequest,
  Response: AddObjectResponse,
  md5sum() { return '3fb8af17854d0a0aa1df05f91f7ba459'; },
  datatype() { return 'hector_worldmodel_msgs/AddObject'; }
};
