// Auto-generated. Do not edit!

// (in-package hector_worldmodel_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let ObjectModel = require('../msg/ObjectModel.js');

//-----------------------------------------------------------

class GetObjectModelRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
    }
    else {
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetObjectModelRequest
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetObjectModelRequest
    let len;
    let data = new GetObjectModelRequest(null);
    return data;
  }

  static getMessageSize(object) {
    return 0;
  }

  static datatype() {
    // Returns string type for a service object
    return 'hector_worldmodel_msgs/GetObjectModelRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd41d8cd98f00b204e9800998ecf8427e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetObjectModelRequest(null);
    return resolved;
    }
};

class GetObjectModelResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.model = null;
    }
    else {
      if (initObj.hasOwnProperty('model')) {
        this.model = initObj.model
      }
      else {
        this.model = new ObjectModel();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetObjectModelResponse
    // Serialize message field [model]
    bufferOffset = ObjectModel.serialize(obj.model, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetObjectModelResponse
    let len;
    let data = new GetObjectModelResponse(null);
    // Deserialize message field [model]
    data.model = ObjectModel.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += ObjectModel.getMessageSize(object.model);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'hector_worldmodel_msgs/GetObjectModelResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '361f26c46d94ccf48a94c138afa225e8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ObjectModel model
    
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectModel
    # hector_worldmodel_msgs/ObjectModel
    # This message represents a collection of known objects.
    
    Header header
    Object[] objects
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: hector_worldmodel_msgs/Object
    # hector_worldmodel_msgs/Object
    # This message represents an estimate of an object's pose and identity.
    
    # The header.
    #   stamp: Timestamp of last update.
    #   frame_id: Coordinate frame, in which the pose is given
    Header header
    
    # The pose
    geometry_msgs/PoseWithCovariance pose
    
    # Further information about the object
    ObjectInfo info
    
    # The tracked state of the object
    ObjectState state
    
    ================================================================================
    MSG: geometry_msgs/PoseWithCovariance
    # This represents a pose in free space with uncertainty.
    
    Pose pose
    
    # Row-major representation of the 6x6 covariance matrix
    # The orientation parameters use a fixed-axis representation.
    # In order, the parameters are:
    # (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
    float64[36] covariance
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectInfo
    # hector_worldmodel_msgs/ObjectInfo
    # This message contains information about the estimated class affiliation, object id and corresponding support
    
    # A string identifying the object's class (all objects of a class look the same)
    string class_id
    
    # A string identifying the specific object
    string object_id
    
    # A string that contains the name or a description of the specific object
    string name
    
    # The support (degree of belief) of the object's presence given as log odd ratio
    float32 support
    
    
    ================================================================================
    MSG: hector_worldmodel_msgs/ObjectState
    # The state of an object estimate used to track
    # states smaller than 0 disable all updates
    
    # Predefined states. Use states smaller than 0 or bigger than 63 for user defined states.
    int8 UNKNOWN = 0
    int8 PENDING = 1
    int8 ACTIVE  = 2
    int8 INACTIVE = 3
    int8 CONFIRMED = -1
    int8 DISCARDED = -2
    int8 APPROACHING = -3
    
    int8 state
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetObjectModelResponse(null);
    if (msg.model !== undefined) {
      resolved.model = ObjectModel.Resolve(msg.model)
    }
    else {
      resolved.model = new ObjectModel()
    }

    return resolved;
    }
};

module.exports = {
  Request: GetObjectModelRequest,
  Response: GetObjectModelResponse,
  md5sum() { return '361f26c46d94ccf48a94c138afa225e8'; },
  datatype() { return 'hector_worldmodel_msgs/GetObjectModel'; }
};
