// Auto-generated. Do not edit!

// (in-package hector_worldmodel_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PosePercept = require('../msg/PosePercept.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class VerifyPerceptRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.percept = null;
    }
    else {
      if (initObj.hasOwnProperty('percept')) {
        this.percept = initObj.percept
      }
      else {
        this.percept = new PosePercept();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VerifyPerceptRequest
    // Serialize message field [percept]
    bufferOffset = PosePercept.serialize(obj.percept, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VerifyPerceptRequest
    let len;
    let data = new VerifyPerceptRequest(null);
    // Deserialize message field [percept]
    data.percept = PosePercept.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += PosePercept.getMessageSize(object.percept);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'hector_worldmodel_msgs/VerifyPerceptRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9bd63c0c584500367d789d059094e625';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    PosePercept percept
    
    ================================================================================
    MSG: hector_worldmodel_msgs/PosePercept
    # hector_worldmodel_msgs/PosePercept
    # This message represents an observation of an object in a single image.
    
    # The header should equal the header of the corresponding image.
    Header header
    
    # The estimated pose of the object with its covariance
    geometry_msgs/PoseWithCovariance pose
    
    # Additional information about the percept
    PerceptInfo info
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/PoseWithCovariance
    # This represents a pose in free space with uncertainty.
    
    Pose pose
    
    # Row-major representation of the 6x6 covariance matrix
    # The orientation parameters use a fixed-axis representation.
    # In order, the parameters are:
    # (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
    float64[36] covariance
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: hector_worldmodel_msgs/PerceptInfo
    # hector_worldmodel_msgs/PerceptInfo
    # This message contains information about the estimated class and object identity 
    
    # A string identifying the object's class (all objects of a class look the same)
    string class_id
    
    # The class association support of the observation
    # The support is the log odd likelihood ratio given by log(p(y/observation y belongs to object of class class_id) / p(y/observation y is a false positive))
    float32 class_support
    
    # A string identifying a specific object
    string object_id
    
    # The object association support of the observation
    # The support is the log odd likelihood ratio given by log(p(observation belongs to object object_id) / p(observation is false positive or belongs to another object))
    float32 object_support
    
    # A string that contains the name or a description of the specific object
    string name
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VerifyPerceptRequest(null);
    if (msg.percept !== undefined) {
      resolved.percept = PosePercept.Resolve(msg.percept)
    }
    else {
      resolved.percept = new PosePercept()
    }

    return resolved;
    }
};

class VerifyPerceptResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.response = null;
    }
    else {
      if (initObj.hasOwnProperty('response')) {
        this.response = initObj.response
      }
      else {
        this.response = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VerifyPerceptResponse
    // Serialize message field [response]
    bufferOffset = _serializer.uint8(obj.response, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VerifyPerceptResponse
    let len;
    let data = new VerifyPerceptResponse(null);
    // Deserialize message field [response]
    data.response = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a service object
    return 'hector_worldmodel_msgs/VerifyPerceptResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a4e2509e523147799a63deb6a40a0721';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    uint8 response
    uint8 UNKNOWN = 0
    uint8 DISCARD = 1
    uint8 CONFIRM = 2
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VerifyPerceptResponse(null);
    if (msg.response !== undefined) {
      resolved.response = msg.response;
    }
    else {
      resolved.response = 0
    }

    return resolved;
    }
};

// Constants for message
VerifyPerceptResponse.Constants = {
  UNKNOWN: 0,
  DISCARD: 1,
  CONFIRM: 2,
}

module.exports = {
  Request: VerifyPerceptRequest,
  Response: VerifyPerceptResponse,
  md5sum() { return '4274b9c0812a5a8c107aa29835bb1b45'; },
  datatype() { return 'hector_worldmodel_msgs/VerifyPercept'; }
};
